#include <pthread.h>
#include <stdlib.h>
#include <stdio.h>
#define SIZE 1024

unsigned int t[SIZE];
void *sum(void *);
typedef struct{int *p; int i;} ST;

main(){
 //le thread principal démarre sur le coeur 0
 unsigned long s;
 ST st;
 pthread_t tid;
 unsigned int i;
 //le tableau t est créé
 //il occupe la hiérarchie, jusqu'au cache L1 du coeur 0
 for (i=0;i<SIZE;i++) t[i]=i;
 st.p=t; st.i=SIZE;
 //un thread secondaire est créé
 //il démarre sur le coeur 1
 //le thread principal lui transmet st, c-à-d le tableau global
 pthread_create(&tid,NULL,sum,(void *)&st);
 //le thread principal sur le coeur 0 attend le thread secondaire sur le coeur 1
 //le thread secondaire transmet son résultat (code de retour, écrit dans s)
 pthread_join(tid,(void *)&s);
 printf("sum: %lu\n",s);
}

void *sum(void *st){
 ST str1,str2;
 unsigned long s,s1,s2;
 pthread_t tid1, tid2;
 //s'il y a plus de 2 éléments à additionner
 if (((ST *)st)->i>2){
   str1.p=((ST *)st)->p; str1.i=((ST *)st)->i/2;
   //deux threads sont créés, exécutés sur deux coeurs
   //le thread courant leur transmet str1 et str2, c-à-d une tranche de tableau
   pthread_create(&tid1,NULL,sum,(void *)&str1);
   str2.p=((ST *)st)->p + ((ST *)st)->i/2; str2.i=((ST *)st)->i/2;
   pthread_create(&tid2,NULL,sum,(void *)&str2);
   //le thread courant attend les deux threads
   //chacun transmet son résultat (codes de retour écrits dans s1 et s2)
   pthread_join(tid1,(void *)&s1);
   pthread_join(tid2,(void *)&s2);
 }
 else{s1=((ST *)st)->p[0];s2=((ST *)st)->p[1];}
 s=s1+s2;
 //code de retour du thread: somme de s1 et s2
 pthread_exit((void *)s);
}
//pour SIZE=16:
//thread main
// thread 1, pour calculer la somme de t[0,7]
//  thread 3, pour calculer la somme de t[0,3]
//   thread 7, pour calculer la somme t[0,1]
//   thread 8, pour calculer la somme t[2,3]
//  thread 4, pour calculer la somme de t[4,7]
//   thread 9, pour calculer la somme t[4,5]
//   thread 10, pour calculer la somme t[6,7]
// thread 2, pour calculer la somme de t[8,15]
//  thread 5, pour calculer la somme de t[8,11]
//   thread 11, pour calculer la somme t[8,9]
//   thread 12, pour calculer la somme t[10,11]
//  thread 6, pour calculer la somme de t[12,15]
//   thread 13, pour calculer la somme t[12,13]
//   thread 14, pour calculer la somme t[14,15]
